;Wmf-View (extended)
;Get size of Wmf-File (only Wmf2-portable <-which you can find in the end mostly, and Emf)
;Mischa Brandt

Structure sizeofwmf
  w.l
  h.l
EndStructure
Global WmfSize.sizeofwmf


Procedure LoadWmfImage(name.s)
  If name<>""
    WmfSize\w=-1:WmfSize\h=-1
    hemf = GetEnhMetaFile_(name)
    If hemf=0
      hmf = GetMetaFile_(name)
      If hmf=0
        size=FileSize(name)-22
        ReadFile(1,name)
          FileSeek(6)
          l=ReadWord():t=ReadWord()
          r=ReadWord():b=ReadWord()
          WmfSize\w=r-l:WmfSize\h=b-t
          FileSeek(22)
          *buffer=AllocateMemory(1,size,0)
          ReadData(*buffer,size)
        CloseFile(1)
      Else
        size = GetMetaFileBitsEx_(hmf,size,0)
        *buffer=AllocateMemory(1,size,0)
        GetMetaFileBitsEx_(hmf,size,*buffer)
      EndIf
      hemf = SetWinMetaFileBits_(size,*buffer,GetDC_(0),0)
    Else
      ReadFile(1,name)
        FileSeek(8)
        l=ReadLong():t=ReadLong()
        r=ReadLong():b=ReadLong()
        WmfSize\w=r-l+1:WmfSize\h=b-t+1
      CloseFile(1)
    EndIf
    ProcedureReturn hemf
  EndIf
EndProcedure

Procedure DrawWmfImage(hnd,sdc,x,y,b,h)
  SetRect_(WmfRect.RECT,x,y,x+b-1,y+h-1)
  PlayEnhMetaFile_(sdc,hnd,WmfRect)
EndProcedure

Procedure FreeWmfImage(hnd)
  DeleteEnhMetaFile_(hnd)
EndProcedure

hwnd=OpenWindow(0, 100, 100, 400, 300, #PB_Window_SystemMenu,"Wmf-Test")
CreateGadgetList(hwnd)
ButtonGadget(1, 100, 250, 200, 20, "Load Wmf")

Repeat
  EventID = WaitWindowEvent()
  If EventID = #PB_EventGadget
    Select EventGadgetID()
      Case 1
        image=LoadWmfImage(OpenFileRequester("Open","","Metafile|*.wmf;*.emf",0))
        MessageRequester("Size of Clipart","Width: "+Str(WmfSize\w)+Chr(13)+Chr(10)+"Height: "+Str(WmfSize\h),0)
        DrawWmfImage(image,GetDC_(hwnd),100,25,200,200)
        FreeWmfImage(image)
    EndSelect
  EndIf
Until EventID = #PB_EventCloseWindow
 
; ExecutableFormat=Windows
; CursorPosition=66
; FirstLine=45
; Executable=D:\test\wmf\wmf.exe
; DisableDebugger
; EOF